Foreman - Bug #6958

Hostgroup provisioning does not support nested groups
08/06/2014 09:54 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Amir Fefer
Category: Unattended installations
Target version: 1.12.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1127267 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3489
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1127267
Description of problem:
The host group interface provides the opportunity to nest host groups, with host groups inheriting parameters from parents.

When the default PXE menu is created however, this nesting is not replicated and only the final element of the hostgroup path is
inserted into the kickstart URL.

e.g. we might have nested groups:

dev/SAPServers

ga/SAPServers

prod/SAPServers

where dev, ga and prod have e.g. different root passwords.

However, the PXE template generated will generate an identical kickstart URL for each group:

http:/foreman.example.com/unattended/template/kickstart-templ/SAPServers

and all servers will install with parameters from the first host group (e.g. dev/SAPServers)

Version-Release number of selected component (if applicable):
6 beta

How reproducible:
always

Steps to Reproduce:

1. Set up nested host groups

2. Generate default PXE menu

3. PXE boot host

4. Hit tab to inspect the kickstart URL

Actual results:
As above, kickstart URL only contains the last path element of the hostgroup and therefore are not unique to each hostgroup

Expected results:
kickstart URLs should be unique to each hostgroup to ensure that @host.params are inherited from the correct parent hostgroup.

Additional info:

Associated revisions

Revision 06cd3955 - 05/06/2016 11:02 AM - Amir Fefer
Fixes #6958 - supports in nested hostgroup in default PXE menu
https://bugzilla.redhat.com/show_bug.cgi?id=1127267
http://foreman.example.com/unattended/template/kickstart-templ/SAPServers

The host group interface provides the opportunity to nest hostgroups,
with host groups inheriting parameters from parents.

when the default PXE menu is created however,

this nesting is not replicated, and only the final element

of the hostgroup path is inserted into the kickstart URL.

History

#1 - 08/06/2014 09:55 AM - Dominic Cleal

- Category set to Unattended installations

#2 - 03/18/2016 11:15 AM - Bryan Kearney

Proposed patch from downstream.

patch po—f<<EOF

— /usr/share/foreman/app/controllers/unattended_controller.rb

+++ /usr/share/foreman/app/controllers/unattended_controller.rb

@ -44,7 +44,7 @

return head(:not_found) unless (params.has_key?("id") and params.has_key?(:hostgroup))

template = ConfigTemplate.find_by_name (params['id'])
= @host = Hostgroup.find_by_name (params|['hostgroup'])
+ @host = Hostgroup.find_by_title (params['hostgroup'].gsub('::"',"'/"))

return head(:not_found) unless template and @host

EOF
patch p6—f<<EOF

- /usr/share/foreman/app/controllers/api/v2/config_templates_controller.rb
+++ /usr/share/foreman/app/controllers/api/v2/config_templates_controller.rb
@ -97,7 +97,7 @ module Api

url_for :only_path => false, :action => :template, :controller => '/unattended',

:protocol => protocol, :host => host, :port => port,
= :id => template.name, :hostgroup => hostgroup.name
+ :id => template.name, :hostgroup => hostgroup.title.gsub('/','::")

end
def process_template_kind

EOF
patch pb—f<<EOF

— /usr/share/foreman/app/controllers/config_templates_controller.rb
+++ /usr/share/foreman/app/controllers/config_templates_controller.rb
@ -69,7 +69,7 @

def default_template_url template, hostgroup
url_for :only_path => false, :action => :template, :controller => '/unattended',
= :id => template.name, :hostgroup => hostgroup.name
+ :id => template.name, :hostgroup => hostgroup.title.gsub('/','::")
end

def controller_permission
EOF

#3 - 03/22/2016 04:35 AM - Ohad Levy

- Assignee set to Amir Fefer

#4 - 05/03/2016 09:52 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3489 added

#5 - 05/06/2016 12:02 PM - Amir Fefer
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 06cd3955¢c9b2b48289e6698b195f4e36ad8aefbc.
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/06cd3955c9b2b48289e6698b195f4e36ad8aefbc

#6 - 05/09/2016 04:23 AM - Dominic Cleal

- translation missing: en.field_release set to 136
